#ifndef MAX_WINDOWS
#define MAX_WINDOWS            1
#endif
#ifndef MAX_OBJECTS
#define MAX_OBJECTS           50
#endif
#ifndef MAX_CHARS
#define MAX_CHARS             50
#endif
#ifndef MAX_CHILDREN
#define MAX_CHILDREN          10
#endif
#ifndef MAX_TOPS_OF_OBJECT
#define MAX_TOPS_OF_OBJECT   128
#endif
#ifndef MAX_TOPS_OF_POLYGON
#define MAX_TOPS_OF_POLYGON   32
#endif
#ifndef MAX_POLYGONS
#define MAX_POLYGONS         128
#endif
#ifndef MAX_EYES
#define MAX_EYES              10
#endif
#ifndef MAX_LIGHTS
#define MAX_LIGHTS            10
#endif

#define NM_COLORCELLS        256

#define ON                     1
#define OFF                    0
#define TURN                  -1

#define NULL_CHR              -1

#define NULL_I         -16777216
#define NULL_D           -999999.9

#define INHERITANCE            0
#define BROTHER                1
#define INDEPENDANCE           2

#define NONE                -999
#define ALL                 -998

#define ERROR_CODE            -1
#define SUCCESS_CODE           0
#define R_OVER                -2

#define OUT_OF_SCREEN     999999.9
#define POINT_NONE        999999

#define RGB                    0
#define SCALE                  1

#define MAT                    0
#define PLASTIC                1
#define METAL                  2

#define DEFAULT_YON_CLIPPING_DISTANCE  10000.0

#define DEFAULT_WINDOW_WIDTH     640
#define DEFAULT_WINDOW_HEIGHT    480
#define DEFAULT_SCREEN_WIDTH       1.0
#define DEFAULT_SCREEN_HEIGHT      0.75
#define DEFAULT_SCREEN_DISTANCE    1.0
#define DEFAULT_COLOR_TYPE          RGB
#define DEFAULT_AIR_SHADING    10000.0
#define DEFAULT_RGB_SCALE_R        1.0
#define DEFAULT_RGB_SCALE_G        1.0
#define DEFAULT_RGB_SCALE_B        1.0

#define DEFAULT_NM_RED             6
#define DEFAULT_NM_GREEN           8
#define DEFAULT_NM_BLUE            4

#define RESIZE_DEFAULT             0
#define RESIZE_WIDTH               1
#define RESIZE_HEIGHT              2
#define RESIZE_SHORT               3
#define RESIZE_LONG                4

#ifndef PI
#define PI                         3.1415926535897932384626433832795
#endif

#ifndef RAND_MAX
#define RAND_MAX          2147483647
#endif

#define THRESHOLD_FOR_QUICKSORT   10
#define STACKSIZE_FOR_QUICKSORT   32
